const Main = imports.ui.main;
const St = imports.gi.St;
const Lang = imports.lang;
const PanelMenu = imports.ui.panelMenu;
const UserMenu = imports.ui.userMenu;

function QuitButton() {
    this._init.apply(this, arguments);
}

QuitButton.prototype = {
	__proto__: PanelMenu.Button.prototype,
    
	_init: function()
	{		
		this.userMenuButtonBox = Main.panel._statusArea['userMenu'].menu.box;
		this.items = this.userMenuButtonBox.get_children();

		PanelMenu.Button.prototype._init.call(this, St.Align.START);
		
		// Text == Name
		this.userName = Main.panel._statusArea['userMenu']._name;
		this._name = new St.Label({text:this.userName.get_text()});
		
		let userNameClutter = this.userName.clutter_text;
		userNameClutter.connect('text-changed', Lang.bind(this, this._updateText));
		this.userName.connect('hide', Lang.bind(this, this._hideText));
		this.userName.connect('show', Lang.bind(this, this._showText));
		
		this.userName.add_style_class_name("hideWithoutHiding");
		this.userName.get_parent().get_parent().add_style_class_name("panelButtonWidth");
		Main.panel._statusArea['userMenu']._iconBox.add_style_class_name("hackCenteredIcon");
		
		// Icon == Quit		
		this._quitIcon = new St.Icon({'icon-name': 'system-shutdown', 'icon-size':16});
		
		// Text or Icon ?
		if (this.userName.get_paint_visibility() == true && this.userName.get_text() != "" )
			{ this.actor.add_actor(this._name); }
		else	{ this.actor.add_actor(this._quitIcon); }
		
		// Menu == All after "System Settings"
    		let i;
		for (i=0 ; i<this.items.length; i++)
		{
			let label = this.items[i]._delegate.label;
			if (label != undefined && ( label.get_text() == _("System Settings")
			                         || label.get_text() == _("Advanced Settings") // For "Advanced Settings in UserMenu" Extension
			                         || label.get_text() == "Advanced Settings"    // unuseful, but...
			                         )) break;
		}
		for (; i<this.items.length; i++)
		{
			let item = this.items[i];
			item.reparent(this.menu.box);
			item._delegate.connect('activate', Lang.bind(this, function() { this.menu.close(); }));
		}
	},

	_updateText: function() {
		this._name.set_text(this.userName.get_text())
	},
	_showText: function() {
		if (this.userName.get_text() != "") {
			this.actor.remove_actor(this._quitIcon);
			this.actor.add_actor(this._name);
		}
	},
	_hideText: function() {
		this.actor.remove_actor(this._name);
		this.actor.add_actor(this._quitIcon);
	},
	
	cleanAllYouCan: function(){
		this.userName.remove_style_class_name("hideWithoutHiding");
		this.userName.get_parent().get_parent().remove_style_class_name("panelButtonWidth");
		Main.panel._statusArea['userMenu']._iconBox.remove_style_class_name("hackCenteredIcon");
		
		let children = this.menu.box.get_children();
		for (i=0 ; i<children.length; i++) children[i].reparent(this.userMenuButtonBox);
	}
}

function init() {}

let _QuitButton;

function enable() {
	_QuitButton = new QuitButton;
	Main.panel.addToStatusArea('system-shutdown', _QuitButton, 100);	// may be considered as a hack, I think...
}

function disable() {
	_QuitButton.cleanAllYouCan();
	_QuitButton.destroy();
}
